package com.vulnit.projects.js.elements;

/**
 * A javascript comment
 * 
 * @author rmillet
 * 
 */
public final class JsComment extends JsElement {
	private final boolean multiline;

	/**
	 * 
	 * @param text
	 *            content of the comment
	 * @param multiline
	 *            <code>true</code> if is is a multiline comment
	 */
	public JsComment(String text, boolean multiline) {
		super(text);
		this.multiline = multiline;
	}

	@Override
	public String toString() {
		if (this.multiline) {
			return "/*" + this.text + "*/";
		}

		return "//" + this.text + "\n";
	}

	/**
	 * 
	 * @return the multiline status
	 */
	public boolean isMultiline() {
		return multiline;
	}
}
