package com.vulnit.projects.js.elements;

/**
 * Represents a string
 * 
 * @author rmillet
 * 
 */
public final class JsString extends JsElement {
	private final char type;

	/**
	 * 
	 * @param text
	 *            The value
	 * @param type
	 *            The type (Single or double quotes)
	 */
	public JsString(String text, char type) {
		super(text);
		this.type = type;
	}

	@Override
	public String toString() {
		return this.type + this.text.replace(String.valueOf(this.type), "\\" + this.type)
				+ this.type;
	}

	/**
	 * 
	 * @return The type (Single or double quotes)
	 */
	public char getType() {
		return type;
	}
}
