package com.vulnit.projects.xss;

/**
 * Report for XSS found
 * 
 * @author rmillet
 * 
 */
public final class XssReport {
	private final String payload;
	private final String attributeName;
	private final String display;

	/**
	 * 
	 * @param payload
	 *            Successful payload
	 * @param attributeName
	 *            Name of the attribute injected
	 * @param display
	 *            URL and post data representing the injection
	 */
	public XssReport(String payload, String attributeName, String display) {
		this.payload = payload;
		this.attributeName = attributeName;
		this.display = display;
	}

	/**
	 * 
	 * @return the name of the attribute injected
	 */
	public String getAttributeName() {
		return attributeName;
	}

	@Override
	public String toString() {
		return display;
	}

	/**
	 * 
	 * @return the successful payload
	 */
	public String getPayload() {
		return payload;
	}
}
