package com.vulnit.projects.xss.plugins;

import java.util.Random;

import org.jsoup.nodes.Document;
import org.jsoup.select.Elements;

/**
 * Plugin class
 * 
 * @author rmillet
 * 
 */
public abstract class Plugin {
	/** Tag to inject in the payload */
	protected static String Tag;
	protected static String NumTag;

	private static String TAG = "VulnIT";
	private static String NUM_TAG = "33155949271";

	private static final Random RANDOM = new Random();
	private static final char[] CHARS = "abcdefghijklmnopqrstuvwxyz".toCharArray();

	static {
		generateTags();
	}

	/**
	 * Returns the initial calculated payload.
	 * 
	 * @param elements
	 *            The elements where searchText was found
	 * @param searchText
	 *            The text injected
	 * @return A payload or <code>null</code> if the plugin don't know how to handle this position.
	 */
	public abstract String getInitialPayload(Elements elements, String searchText);

	/**
	 * 
	 * @return A new payload or <code>null</code> if the plugin has no new payload (called if the
	 *         previous injection was not successful)
	 */
	public abstract String getPayload();

	/**
	 * 
	 * @param document
	 *            The {@link Document} obatained with the last payload
	 * @return <code>true</code> if the injection is successful
	 */
	public abstract boolean isInjectionSuccessful(Document document);

	/**
	 * 
	 * @param tag
	 *            The new String tag
	 */
	public static void setTag(String tag) {
		TAG = tag;
	}

	/**
	 * 
	 * @param numTag
	 *            The new numeric tag
	 */
	public static void setNumTag(String numTag) {
		NUM_TAG = numTag;
	}

	/**
	 * 
	 * @return a string composed from Tag and a random string
	 */
	public static String getRandomTag() {
		StringBuilder sb = new StringBuilder();
		sb.append(Tag);
		for (int i = 0; i < 10; ++i) {
			sb.append(CHARS[Math.abs(RANDOM.nextInt()) % CHARS.length]);
		}
		return sb.toString().toLowerCase();
	}

	/**
	 * Generate new Tags
	 */
	public static void generateTags() {
		String time = String.valueOf(System.currentTimeMillis());
		Tag = TAG + time;
		NumTag = NUM_TAG + time;
	}
}
